Index: src/northbridge/via/vx800/dram_init.c
===================================================================
--- src/northbridge/via/vx800/dram_init.c	(Revision 4427)
+++ src/northbridge/via/vx800/dram_init.c	(Arbeitskopie)
@@ -5,7 +5,7 @@
  *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License as published by
- * the Free Software Foundation; either version 2 of the License.
+ * the Free Software Foundation; version 2 of the License.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
@@ -17,69 +17,139 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  */
 
-CB_STATUS DDR2_DRAM_INIT()
+#include <spd.h>
+#include <sdram_mode.h>
+#include <delay.h>
+
+#define DEBUG_RAM_SETUP 1
+
+#ifdef DEBUG_RAM_SETUP
+#define PRINT_DEBUG_MEM(x)		print_debug(x)
+#define PRINT_DEBUG_MEM_HEX8(x)		print_debug_hex8(x)
+#define PRINT_DEBUG_MEM_HEX16(x)	print_debug_hex16(x)
+#define PRINT_DEBUG_MEM_HEX32(x)	print_debug_hex32(x)
+#define DUMPNORTH()			dump_pci_device(PCI_DEV(0, 0, 0))
+#else
+#define PRINT_DEBUG_MEM(x)
+#define PRINT_DEBUG_MEM_HEX8(x)
+#define PRINT_DEBUG_MEM_HEX16(x)
+#define PRINT_DEBUG_MEM_HEX32(x)
+#define DUMPNORTH()
+#endif
+
+ #include "northbridge/via/vx800/ddr2init/dram_translatorddr2init.c"
+ #include "northbridge/via/vx800/ddr2init/dram_init.h"
+ #include "northbridge/via/vx800/vx800_early_smbus.c"
+ #include "northbridge/via/vx800/ddr2init/dram_util.h"
+ #include "northbridge/via/vx800/ddr2init/dram_util.c"
+ #include "northbridge/via/vx800/ddr2init/dram_detection.c"
+ #include "northbridge/via/vx800/ddr2init/dram_freq_setting.c"
+ #include "northbridge/via/vx800/ddr2init/dram_timing_setting.c"
+ #include "northbridge/via/vx800/ddr2init/dram_drdy_bl.c"
+ #include "northbridge/via/vx800/ddr2init/dram_driving_setting.c"
+ #include "northbridge/via/vx800/ddr2init/dram_clk_ctrl.c"
+ #include "northbridge/via/vx800/ddr2init/dram_devInit.c"
+ #include "northbridge/via/vx800/ddr2init/dram_rank_map.c"
+ #include "northbridge/via/vx800/ddr2init/dram_dqs_search.c"
+ #include "northbridge/via/vx800/ddr2init/dram_final_setting.c"
+ #include "northbridge/via/vx800/ddr2init/uma_ram_setting.c"
+
+/*
+ * Support one dimm with up to 2 ranks
+ */
+static void ddr2_ram_setup()
 {
-	CB_STATUS Status;
-	u8 i;
+	u8 i, rambits, data;
+	u16 boot_mode;
 	u32 RamSize;
-	BOOLEAN bTest;
 	DRAM_SYS_ATTR DramAttr;
 
 	PRINT_DEBUG_MEM("DRAM_INIT \r");
 
-	memset(&DramAttr, 0, sizeof(DRAM_SYS_ATTR));
-	/*Step1 DRAM Detection; DDR1 or DDR2; Get SPD Data; Rank Presence;64 or 128bit; Unbuffered or registered; 1T or 2T */
+	memset (&DramAttr, 0,sizeof (DRAM_SYS_ATTR));
+	
+	/*Step1 DRAM Detection; DDR1 or DDR2; Get SPD Data; Rank Presence;64 or 128bit; Unbuffered or registered; 1T or 2T*/
 	DRAMDetect(&DramAttr);
+	
+	/* When resume from s3, draminit is skiped, so need to recovery any PCI register related to draminit. 
+	and d0f3 didnt lost its Power during whole s3 time, so any register not belongs to d0f3 need to be recoveried . */
+	boot_mode = inw(VX800_ACPI_IO_BASE + 0x04);
+	boot_mode= ((boot_mode& (7 << 10)) >> 10) == 1 ? 3 : 0;	
+	if (boot_mode==3) {
+		u8 ramregs[] = {0x43, 0x42, 0x41, 0x40};
+		device_t dev;
+		print_debug("This is a S3 wakeup\r\n");
+		/* begin to get ram size, 43,42 41 40 contains the end address of last rank in ddr2-slot */
+		dev=PCI_DEV(0, 0, 3);
+		for(rambits = 0, i = 0; i < ARRAY_SIZE(ramregs); i++) {
+			rambits = pci_read_config8(dev, ramregs[i]);
+			if (rambits != 0)
+				break;
+		}
 
-	//Step2 set Frequency; calculate CL and Frequncy from SPD data; set the Frequency
-	DRAMFreqSetting(&DramAttr);
-	//Step3 Set DRAM Timing; CL, tRP, tRCD, tRAS, tRFC, tRRD, tWR, tWTR, tRTP
-	DRAMTimingSetting(&DramAttr);
-	//Step4 DRDY
-	DRAMDRDYSetting(&DramAttr);
-	//Step5 Burst length
-	DRAMBurstLength(&DramAttr);
-	//Step6 DRAM Driving Adjustment
-	DRAMDriving(&DramAttr);
-	//Step7 duty cycle control
-	DutyCycleCtrl(&DramAttr);
-	//Step8 DRAM clock phase and delay control
-	DRAMClkCtrl(&DramAttr);
-	//Step9 set register before init DRAM device
-	DRAMRegInitValue(&DramAttr);
-	//Step10 DDR and DDR2 initialize process
-	DRAMInitializeProc(&DramAttr);
+		DRAMDRDYSetting (&DramAttr);
 
-	//Step13 Interleave function in rankmap.c
-	DRAMBankInterleave(&DramAttr);
-	//Step14 Sizing
-	DRAMSizingMATypeM(&DramAttr);
+		data = 0x80;//this value is same with DevInit.c
+		pci_write_config8(PCI_DEV(0,0,4), 0xa3, data);
+		pci_write_config8(PCI_DEV(0,17,7), 0x60, rambits<<2);
+		data=pci_read_config8(MEMCTRL, 0x88);
+		pci_write_config8(PCI_DEV(0,17,7), 0xE5, data);
 
-	//Step11 Search DQS and DQ output delay
-	DRAMDQSOutputSearch(&DramAttr);
-	//Step12 Search DQS  input delay
-	DRAMDQSInputSearch(&DramAttr);
+		DRAMRegFinalValue(&DramAttr); 
+		SetUMARam();		
+	} else {    		
+		//Step2 set Frequency; calculate CL and Frequncy from SPD data; set the Frequency
+		DRAMFreqSetting(&DramAttr);
+		//Step3 Set DRAM Timing; CL, tRP, tRCD, tRAS, tRFC, tRRD, tWR, tWTR, tRTP
+		DRAMTimingSetting(&DramAttr);
+		//Step4 DRDY
+		DRAMDRDYSetting (&DramAttr);
+		//Step5 Burst length
+		DRAMBurstLength(&DramAttr);
+		//Step6 DRAM Driving Adjustment
+		DRAMDriving(&DramAttr);
+		//Step7 duty cycle control
+		DutyCycleCtrl(&DramAttr);
+		//Step8 DRAM clock phase and delay control
+		DRAMClkCtrl(&DramAttr);
+		//Step9 set register before init DRAM device
+		DRAMRegInitValue(&DramAttr);
+		//Step10 DDR and DDR2 initialize process
+		DRAMInitializeProc(&DramAttr);
+	
+		//Step13 Interleave function in rankmap.c
+		DRAMBankInterleave(&DramAttr);
+		//Step14 Sizing
+		DRAMSizingMATypeM(&DramAttr);
 
-	//Step15 DDR fresh counter setting
-	DRAMRefreshCounter(&DramAttr);
-	//Step16 Final register setting for improve performance
-	DRAMRegFinalValue(&DramAttr);
+		//Step11 Search DQS and DQ output delay
+   		DRAMDQSOutputSearch(&DramAttr);
+		//Step12 Search DQS  input delay
+   		DRAMDQSInputSearch(&DramAttr); 
+	
+		//Step15 DDR fresh counter setting
+		DRAMRefreshCounter(&DramAttr);
+		//Step16 Final register setting for improve performance
+		DRAMRegFinalValue(&DramAttr); 
 
-	RamSize = 0;
-	for (i = 0; i < MAX_RANKS; i++) {
-		if (DramAttr.RankSize[i] == 0) {
+		RamSize = 0;
+		for(i=0;i<MAX_RANKS;i++){
+	  	if (DramAttr.RankSize[i] == 0) {
 			continue;
+		  }
+			RamSize += DramAttr.RankSize[i];
 		}
-		RamSize += DramAttr.RankSize[i];
-	}
-	PRINT_DEBUG_MEM("RamSize=");
-	PRINT_DEBUG_MEM_HEX32(RamSize);
-	PRINT_DEBUG_MEM("\r");
-	DumpRegisters(0, 3);
-	//bTest = DramBaseTest( M1, RamSize - M1 * 2,SPARE, FALSE);
-	/* the memory can not correct work, this is because the user set the incorrect memory
-	   parameter from setup interface.so we must set the boot mode to recovery mode, let
-	   the system to reset and use the spd value to initialize the memory */
-	SetUMARam();
-	return CB_SUCCESS;
+		PRINT_DEBUG_MEM("RamSize=");
+		PRINT_DEBUG_MEM_HEX32(RamSize);
+		PRINT_DEBUG_MEM("\r");
+
+		ram_check(0, 640 * 1024); 
+
+		/*BOOLEAN bTest;
+		bTest = DramBaseTest( M1, RamSize - M1 * 2,SPARE, FALSE);*/
+		/* the memory can not correct work, this is because the user set the incorrect memory
+		parameter from setup interface.so we must set the boot mode to recovery mode, let
+		he system to reset and use the spd value to initialize the memory*/
+		SetUMARam();
+		}   
 }
Index: src/northbridge/via/vx800/dram_init.h
===================================================================
--- src/northbridge/via/vx800/dram_init.h	(Revision 4427)
+++ src/northbridge/via/vx800/dram_init.h	(Arbeitskopie)
@@ -20,6 +20,8 @@
 #ifndef __DRAMINIT_H_
 #define __DRAMINIT_H_
 
+#define MEMCTRL	PCI_DEV(0,0,3)
+
 //Dram Size
 #define M   (1024*1024)
 #define M1  (1*M)
@@ -33,7 +35,7 @@
 #define 	UMASIZE  M64
 
 #define  ENABLE_CHC   0		//CHC enable, how ever, this CHC,used some reg define in CHB
-#define  ENABLE_CHB   0		//CHB enable , CHB is VX800's, VX855 no this CHB.
+#define  ENABLE_CHB   0		//CHB enable , CHB is VX800's, VX800 no this CHB.
 //Dram Freq
 #define DIMMFREQ_800	400
 #define DIMMFREQ_667	333
@@ -108,11 +110,8 @@
 #define SPD_SDRAM_TRFC               42	/*minimum refresh to active / refresh command period */
 
 #define  SPD_DATA_SIZE 44
-//Dram cofig are
-/*the most number of socket*/
-#define  MAX_RAM_SLOTS  2
 
-#define MAX_SOCKETS MAX_RAM_SLOTS
+#define MAX_SOCKETS 2
 #define  MAX_DIMMS     MAX_SOCKETS	/*every sockets can plug one DIMM */
 /*the most number of RANKs on a DIMM*/
 #define  MAX_RANKS  MAX_SOCKETS*2
Index: src/northbridge/via/vx800/vga.c
===================================================================
--- src/northbridge/via/vx800/vga.c	(Revision 4427)
+++ src/northbridge/via/vx800/vga.c	(Arbeitskopie)
@@ -34,9 +34,8 @@
 #include <cpu/x86/msr.h>
 #include "chip.h"
 #include "northbridge.h"
-#include "vgachip.h"
 
-/* PCI Domain 1 Device 0 Function 0 */
+/* PCI Domain 0 Device 1 Function 0 */
 
 #define SR_INDEX	0x3c4
 #define SR_DATA		0x3c5
@@ -68,30 +67,36 @@
 extern u8 acpi_sleep_type;
 static void vga_init(device_t dev)
 {
-	uint8_t reg8;
-
 	print_debug("Initiailizing VGA...\n");
-	u8 tmp8;
-//A20 OPEN
-	tmp8 = inb(0x92);
-	tmp8 = tmp8 | 2;
-	outb(tmp8, 0x92);
+	pci_write_config8(dev, 0x3c, 0x0a);//same with vx800_lpc.c
+}
 
-	//*
-	//pci_write_config8(dev, 0x04, 0x07);
-	//pci_write_config32(dev,0x10, 0xa0000008);
-	//pci_write_config32(dev,0x14, 0xdd000000);
-	pci_write_config32(dev, 0x10, VIACONFIG_VGA_PCI_10);
-	pci_write_config32(dev, 0x14, VIACONFIG_VGA_PCI_14);
-	pci_write_config8(dev, 0x3c, 0x0a);	//same with vx855_lpc.c
-	//*/
-	printk_emerg("file '%s', line %d\n\n", __FILE__, __LINE__);
+static void vx800_vga_enable_resources(device_t dev)
+{     
+	device_t dev_use;
+	u8 data8;
+	u32 data32;
+	pci_dev_enable_resources(dev);
 
-#if 1
-	printk_debug("INSTALL REAL-MODE IDT\n");
-	setup_realmode_idt();
-	printk_debug("DO THE VGA BIOS\n");
+	/*1 enable direct cpu frame buffer access
+	2 set D0F3RxA0A1[11:1] according to address in D1F0Rx10-13h, which was auto set by coreboot as a BAR.
+	*/
+	data32=pci_read_config32(dev, 0x10)&0xfffffff0;
+	dev_use = dev_find_device(PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX800_MEMCTRL, 0);
+	data8=pci_read_config8(dev_use, 0xa1);
+	data8 &=0xf0;
+	data8 |=(u8)(data32>>28);
+	pci_write_config8(dev_use, 0xa1, data8);
+	data8=(u8)(0xfe&(data32>>20));
+	data8=data8|0x01;
+	pci_write_config8(dev_use, 0xa0, data8);
 
+	//turn on GFx memory space access control for S.L(uma buffer in dram) and mmio
+	//THIS SHOULD BE SET AFTER umaseting and before VGABIOS called.
+	dev_use = dev_find_device(PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX800_NB_HOST_CTRL, 0);
+	data8=pci_read_config8(dev_use, 0xD4);
+	data8 |= 0x03;
+	pci_write_config8(dev_use, 0xD4, data8);	
 	do_vgabios();
 	if ((acpi_sleep_type == 3)/* || (PAYLOAD_IS_SEABIOS == 0)*/) {
 		printk_debug("Enable VGA console\n");
@@ -125,7 +130,7 @@
 	printk_emerg("file '%s', line %d\n\n", __FILE__, __LINE__);
 
 }
-
+	
 static void vga_read_resources(device_t dev)
 {
 	dev->rom_address = (void *)(0xffffffff - CONFIG_ROM_SIZE + 1);
@@ -134,15 +139,15 @@
 }
 
 static struct device_operations vga_operations = {
-	.read_resources = vga_read_resources,
-	.set_resources = pci_dev_set_resources,
-	.enable_resources = pci_dev_enable_resources,
-	.init = vga_init,
-	.ops_pci = 0,
+	.read_resources   = vga_read_resources,
+	.set_resources    = pci_dev_set_resources,
+	.enable_resources = vx800_vga_enable_resources,
+	.init             = vga_init,
+	.ops_pci          = 0,
 };
 
 static const struct pci_driver vga_driver __pci_driver = {
 	.ops = &vga_operations,
 	.vendor = PCI_VENDOR_ID_VIA,
-	.device = PCI_DEVICE_ID_VIA_VX855_VGA,
+	.device = PCI_DEVICE_ID_VIA_VX800_VGA,
 };
Index: src/northbridge/via/vx800/uma_ram_setting.c
===================================================================
--- src/northbridge/via/vx800/uma_ram_setting.c	(Revision 4427)
+++ src/northbridge/via/vx800/uma_ram_setting.c	(Arbeitskopie)
@@ -17,8 +17,6 @@
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
  */
 
-#include "pci_rawops.h"
-
 typedef struct __UMA_RAM_tag {
 	u16 DramSize;
 	u8 D0F3Val;
@@ -50,9 +48,6 @@
 #define VGA_PORT_32M	0xF0
 #define VGA_PORT_16M	0xF8
 
-#define VIACONFIG_VGA_PCI_10 0xf8000008
-#define VIACONFIG_VGA_PCI_14 0xfc000000
-
 static const UMARAM UMARamArr[] = {
 	{0, UMARAM_0M, FB_4M, 0xFE},
 	{8, UMARAM_8M, FB_8M, 0xFC},
@@ -64,17 +59,23 @@
 	{512, UMARAM_512M, FB_512M, VGA_PORT_512M},
 	{0xffff, 0xff, 0xff, 0xFF}
 };
+static const  u16 eae9_table[2][4] =
+    {
+	//  FSB others
+       	{250,350,350,350},
+       	//  FSB 800
+       	{250,350,350,400}
+    };
 
 void SetUMARam(void)
 {
-#if 1
 	u8 ramregs[] = { 0x43, 0x42, 0x41, 0x40 };
 	device_t vga_dev = PCI_DEV(0, 1, 0), d0f0_dev = PCI_DEV(0, 0, 0);
 	u8 ByteVal, temp;
 	UMARAM *pUMARamTable;
 	u16 UmaSize;
 	u8 SLD0F3Val, SLD1F0Val, VgaPortVal;
-	u32 RamSize, SLBase, Tmp;
+	u32 RamSize, SLBase, Tmp,last_ram_rank_size;
 	u8 i;
 	PRINT_DEBUG_MEM("Entering vx800 SetUMARam.\n");
 	SLD0F3Val = 0;
@@ -117,12 +118,52 @@
 	//pci_write_config8(MEMCTRL, 0xb4, 0x04);
 
 	//enable CHA and CHB merge mode
-	pci_write_config8(MEMCTRL, 0xde, 0x06);
+	ByteVal=pci_read_config8(MEMCTRL, 0xde);
+	ByteVal= ByteVal & 0xfd;
+	ByteVal= ByteVal | 0x04;
+	pci_write_config8(MEMCTRL, 0xde, ByteVal);
 
-	//if can get the value from setup interface, so get the value
-	//else use the default value
 	UmaSize = CONFIG_VIDEO_MB;
 
+	//check if CONFIG_VIDEO_MB> last_dram_rank_size, if so, have to degraded CONFIG_VIDEO_MB to last_dram_rank_size
+	for(RamSize = 0, i = 0; i < ARRAY_SIZE(ramregs); i++) {
+		RamSize = pci_read_config8(MEMCTRL, ramregs[i]);
+		if (RamSize != 0)
+			break;
+	}
+
+	if((RamSize<<6)==512){
+		ByteVal=pci_read_config8(d0f0_dev, 0xfe);	
+		ByteVal|=0x80;
+		pci_write_config8(d0f0_dev, 0xfe,ByteVal);
+	}
+	
+	last_ram_rank_size=RamSize-pci_read_config8(MEMCTRL, ramregs[i]+8);
+	last_ram_rank_size=last_ram_rank_size<<6;//M size.
+  	if(UmaSize>last_ram_rank_size){
+		UmaSize=last_ram_rank_size;
+		print_emerg("!NOTICE\n");
+		print_emerg("!CONFIG_VIDEO_MB> last_dram_rank_size, have to set UmaSize=last_dram_rank_size=");
+		print_emerg_hex16(UmaSize);
+		print_emerg("");
+		print_emerg("M-HEX\n");
+		print_emerg("!END\n");
+  	}
+	if((RamSize<<6)<=UmaSize){
+		UmaSize=UmaSize>>1;
+		print_emerg("!NOTICE\n");
+		print_emerg("!UmaSize> RamSize, have to set UmaSize= UmaSize/2=");
+		print_emerg_hex16(UmaSize);
+		print_emerg("M-HEX\n");
+		print_emerg("!END\n");
+  	}
+
+	i=MAX_RANKS-i-1;
+	ByteVal=pci_read_config8(MEMCTRL, 0x95);	
+	ByteVal&=0x55;
+	ByteVal|=0x02<<(i*2);
+	pci_write_config8(MEMCTRL, 0x95,ByteVal);
+
 	for (pUMARamTable = UMARamArr; pUMARamTable->DramSize != 0xffff;
 	     pUMARamTable++) {
 		if (UmaSize == pUMARamTable->DramSize) {
@@ -137,7 +178,6 @@
 	ByteVal = (ByteVal & 0x8f) | (SLD0F3Val << 4);
 	pci_write_config8(MEMCTRL, 0xa1, ByteVal);
 
-//      vga_dev = dev_find_device(PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX855_VGA, 0);
 
 	//RxB2 may be for S.L. and RxB1 may be for L. L. 
 	// It is different from Spec.
@@ -155,35 +195,6 @@
 	ByteVal = 0x07;
 	pci_write_config8(vga_dev, 0x04, ByteVal);
 
-	//must set SL and MMIO base, or else when enable GFX memory space, system will hang
-	//set S.L base
-	Tmp = pci_read_config32(vga_dev, 0x10);
-	Tmp = 0xfffffff8;
-	pci_write_config32(vga_dev, 0x10, Tmp);
-	Tmp = pci_read_config32(vga_dev, 0x10);
-	Tmp = VIACONFIG_VGA_PCI_10;
-	pci_write_config32(vga_dev, 0x10, Tmp);
-
-	//set MMIO base
-	Tmp = pci_read_config32(vga_dev, 0x14);
-	Tmp = 0xfffffffC;
-	pci_write_config32(vga_dev, 0x14, Tmp);
-	Tmp = pci_read_config32(vga_dev, 0x14);
-	Tmp = VIACONFIG_VGA_PCI_14;
-	pci_write_config32(vga_dev, 0x14, Tmp);
-
-//enable direct cpu frame buffer access
-	i = pci_rawread_config8(PCI_RAWDEV(0, 0, 3), 0xa1);
-	i = (i & 0xf0) | (VIACONFIG_VGA_PCI_10 >> 28);
-	pci_rawwrite_config8(PCI_RAWDEV(0, 0, 3), 0xa1, i);
-	pci_rawwrite_config8(PCI_RAWDEV(0, 0, 3), 0xa0, 0x01);
-
-	//enable GFx memory space access control for S.L and mmio
-	ByteVal = pci_read_config8(d0f0_dev, 0xD4);
-	ByteVal |= 0x03;
-	//ByteVal |= 0x01;
-	pci_write_config8(d0f0_dev, 0xD4, ByteVal);
-
 	//enable Base VGA 16 Bits Decode
 	ByteVal = pci_read_config8(d0f0_dev, 0xfe);
 	ByteVal |= 0x10;
@@ -203,28 +214,25 @@
 	//ByteVal = 0x03;
 	//pci_write_config8(d0f0_dev, 0xc0, ByteVal);
 
-	//Turn on Graphic chip IO port port access
+	//Enable access of graphic io port 
 	ByteVal = inb(0x03C3);
 	ByteVal |= 0x01;
 	outb(ByteVal, 0x03C3);
 
-	//Turn off Graphic chip Register protection
+	//Disable protect graphic chip register 
 	outb(0x10, 0x03C4);
 
 	ByteVal = inb(0x03C5);
 	ByteVal |= 0x01;
 	outb(ByteVal, 0x03C5);
 
-	//set VGA memory Frequence
+	//set VGA memory frequence
 	//direct IO port 0x3DX to vga io space 0x3C2[0]
 	ByteVal = inb(0x03CC);
 	ByteVal |= 0x03;
 	outb(ByteVal, 0x03C2);
-	//  ByteVal=inb(0x03C2);
-	//   ByteVal |= 0x01;
-	//   outb(ByteVal,0x03C2);
 
-#if 1				//bios porting guide has no this two defination:  3d  on 3d4/3d5 and  39 on 3c4/3c5
+	//bios porting guide has no this two defination:  3d  on 3d4/3d5 and  39 on 3c4/3c5
 	//set frequence 0x3D5.3d[7:4]
 	outb(0x3d, 0x03d4);
 
@@ -260,8 +268,7 @@
 	outb(0x39, 0x03c4);
 	outb(1 << SLD0F3Val, 0x03c5);
 
-#endif
-	// Set S.L. size in GFX's register
+	// Set S.L. size
 	outb(0x68, 0x03c4);
 	outb(VgaPortVal, 0x03c5);
 
@@ -333,99 +340,32 @@
 	ByteVal = (ByteVal & 0xE5) | 0x1A;
 	outb(ByteVal, 0x03d5);
 
-	u8 table3c43c5[0x70] = {
-		0x03, 0x01, 0x0F, 0x00, 0x06, 0x00, 0x00, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x01, 0x78, 0x00, 0x00, 0x00, 0xBE, 0x20, 0x7F,
-		0x60, 0x7F, 0x08, 0x31, 0xCC, 0x00, 0x01, 0x00,
-		0x00, 0x18, 0x10, 0x00, 0x00, 0x00, 0x3D, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x04, 0xF3, 0xFF, 0xFC,
-		0xF8, 0x0C, 0x00, 0x00, 0x40, 0x06, 0x11, 0x22,
-		0x51, 0x10, 0x00, 0x01, 0x19, 0x0C, 0x00, 0xFF,
-		0x38, 0x40, 0x30, 0xFF, 0x70, 0x8C, 0x85, 0x9D,
-		0x80, 0x05, 0x54, 0x90, 0x03, 0x30, 0x00, 0x5F,
-		0x1F, 0x00, 0x00, 0xFF, 0x00, 0x00, 0xFF, 0x00,
-		0x06, 0xDF, 0x00, 0x20, 0x20, 0x00, 0x00, 0x00,
-		0x00, 0x00, 0x00, 0x40, 0x20, 0x00, 0x20, 0x20,
-		0xE0, 0x20, 0xD0, 0x3F, 0x00, 0xE0, 0x00, 0x00
-	};
-	u8 table3d43d5[0x88] = {
-		0x7F, 0x63, 0x63, 0x83, 0x69, 0x19, 0x72, 0xE0,
-		0x00, 0x60, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x58, 0x9C, 0x57, 0x90, 0x00, 0x57, 0x73, 0xE3,
-		0x57, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x0C, 0x00, 0x11, 0x06, 0x00, 0x20, 0x01, 0x34,
-		0xEE, 0x74, 0x01, 0x01, 0x08, 0x84, 0x00, 0x00,
-		0x00, 0xF3, 0x40, 0x90, 0x00, 0x00, 0x00, 0x01,
-		0x00, 0x12, 0x00, 0x02, 0x00, 0x00, 0x10, 0x00,
-		0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D,
-		0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D, 0x9D,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x9D, 0x9D, 0x10,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x9D, 0x9D, 0x9D,
-		0x9D, 0x9D, 0x9D, 0x9D, 0x00, 0x9D, 0x1D, 0x00,
-		0x00, 0x00, 0x1D, 0x1D, 0x1D, 0x1D, 0x1D, 0x1D,
-		0x1D, 0x1D, 0x1D, 0x1D, 0x1D, 0x1D, 0x1D, 0x1D,
-	};
+	ByteVal=pci_read_config8(MEMCTRL, 0xa7);
+	ByteVal |= 0x0c;
+	pci_write_config8(MEMCTRL, 0xa7,ByteVal);
 
-	u8 table3c0space[0xc0] = {
-		0x11, 0x00, 0x10, 0x01, 0x26, 0x3D, 0xFF, 0x00,
-		0x10, 0x3F, 0x00, 0x00, 0x2F, 0x00, 0x22, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x50, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00, 0x00,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-		0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
-	};
-#if 0
-//for(i=0;i<0xc0;i++)
-	for (i = 0; i < 0x40; i++)	//
-	{
-		outb(table3c0space[i], 0x03c0 + i);
-	}
+	ByteVal = 0xee;
+	pci_write_config8(MEMCTRL, 0xa2,ByteVal);
 
-	for (i = 0; i < 0x70; i++) {
-		outb(i, 0x03c4);
-		outb(table3c43c5[i], 0x03c5);
+	ByteVal=pci_read_config8(MEMCTRL, 0xc0);
+	ByteVal |= 0x01;
+	pci_write_config8(MEMCTRL, 0xc0,ByteVal);
+
+	u8 freq;
+	u16	D0F4RxEAE9;
+	ByteVal=pci_read_config8(PCI_DEV(0,0,2), 0x54);
+	freq=pci_read_config8(MEMCTRL, 0x90);
+	freq&=0x07;
+	freq=freq-3;
+	if((ByteVal&0xE0)!=0x60){
+	D0F4RxEAE9=eae9_table[0][freq];
+	}else{
+	D0F4RxEAE9=eae9_table[1][freq];
 	}
-	for (i = 0; i < 0x88; i++) {
-		outb(i, 0x03d4);
-		outb(table3d43d5[i], 0x03d5);
-	}
-	outb(0x92, 0x03d4);
-	outb(0x80, 0x03d5);
+	pci_write_config8(PCI_DEV(0,0,4), 0xe9,(u8)(D0F4RxEAE9));
+	pci_write_config8(PCI_DEV(0,0,4), 0xea,(u8)(D0F4RxEAE9>>8));
 
-	outb(0xa3, 0x03d4);
-	outb(0x00, 0x03d5);
-
-	outb(0xe8, 0x03d4);
-	outb(0x40, 0x03d5);
-#endif
-//3d4 3d freq
-//IO Port / Index: 3X5.3D
-//Scratch Pad Register 4
-
-//    outb(0x39,0x03c4);//
-	//outb(1 << SLD0F3Val ,0x03c5);
-//
-#endif
-
-}
+	ByteVal=pci_read_config8(PCI_DEV(0,17,0), 0x9b);
+	ByteVal|=0x80;
+	pci_write_config8(PCI_DEV(0,17,0), 0x9b,ByteVal);
+}
\ No newline at end of file
Index: src/northbridge/via/vx800/vx800_early_serial.c
===================================================================
--- src/northbridge/via/vx800/vx800_early_serial.c	(Revision 4427)
+++ src/northbridge/via/vx800/vx800_early_serial.c	(Arbeitskopie)
@@ -15,93 +15,125 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
-*/
-
-/*
- * Enable the serial devices on the VIA
  */
-#include <arch/romcc_io.h>
+ 
+#define USE_VCP 0//0 means use DVP
+#define USE_COM1 1
+#define USE_COM2 0
 
-/* The base address is 0x15c, 0x2e, depending on config bytes */
+#define gCom1Base 0x3f8
+#define gCom2Base 0x2f8
+void EmbedComInit()
+{
+	u8 ByteVal;
+	u16 ComBase;
 
-#define SIO_BASE 0x3f0
-#define SIO_DATA  SIO_BASE+1
+	//enable NB multiple function control
+	ByteVal = pci_read_config8(PCI_DEV(0, 0, 0), 0x4f);
+	ByteVal = ByteVal |0x01;
+	pci_write_config8(PCI_DEV(0, 0, 0), 0x4f, ByteVal);
+	//Enable VGA
+	ByteVal = pci_read_config8(PCI_DEV(0, 0, 3), 0xA1);
+	ByteVal = ByteVal |0x80;
+	pci_write_config8(PCI_DEV(0, 0, 3), 0xA1, ByteVal);
+	ByteVal = pci_read_config8(PCI_DEV(0, 0, 3), 0xA7);
+	ByteVal = ByteVal |0x08;
+	pci_write_config8(PCI_DEV(0, 0, 3), 0xA7, ByteVal);
+	//Enable p2p  IO/ and mem
+	ByteVal = pci_read_config8(PCI_DEV(0, 1, 0), 0x4);
+	ByteVal = ByteVal |0x07;
+	pci_write_config8(PCI_DEV(0, 1, 0), 0x4, ByteVal);
+	//Enable Graphic chip IO port port access
+	ByteVal = inb(0x3C3);
+	ByteVal = ByteVal |0x01;
+	outb(ByteVal,0x3C3);
+	//Disable Graphic chip Register protection
+	outb(0x10,0x3C4);
+	ByteVal = inb(0x3C5);
+	ByteVal = ByteVal |0x01;
+	outb(ByteVal,0x3C5);
 
-static void vx800_writesuper(uint8_t reg, uint8_t val)
-{
-	outb(reg, SIO_BASE);
-	outb(val, SIO_DATA);
-}
+	//enable south module pad share
+	outb(0x78,0x3C4);
+	ByteVal = inb(0x3C5);
+	ByteVal = ByteVal |0x80;
+	outb(ByteVal,0x3C5);
 
-static void vx800_writepnpaddr(uint8_t val)
-{
-	outb(val, 0x2e);
-	outb(val, 0xeb);
-}
+	//enable  UART Function multiplex with DVP or VCP pad D17F0Rx46[7,6]
+	ByteVal = pci_read_config8(PCI_DEV(0, 17, 0), 0x46);
+	//multiplex with VCP
+	if(USE_VCP == 1)
+		ByteVal = (ByteVal & 0x3F) | 0x40;
+	//multiplex with DVP
+    else
+		ByteVal = (ByteVal & 0x3F) | 0xC0;
+	pci_write_config8(PCI_DEV(0, 17, 0), 0x46, ByteVal);
 
-static void vx800_writepnpdata(uint8_t val)
-{
-	outb(val, 0x2f);
-	outb(val, 0xeb);
-}
+	//enable embeded com1 and com2 D17F0RxB0[5,4]
+	ByteVal = pci_read_config8(PCI_DEV(0, 17, 0), 0xB0);
+	ByteVal = ByteVal & 0xcf;
+	//multiplex with VCP
+	if(USE_COM1==1)
+		ByteVal = ByteVal | 0x10;
+	if(USE_COM2==1)
+		ByteVal = ByteVal | 0x20;
+	pci_write_config8(PCI_DEV(0, 17, 0), 0xB0, ByteVal);
 
-static void vx800_writesiobyte(uint16_t reg, uint8_t val)
-{
-	outb(val, reg);
-}
+	if(USE_COM1 == 1)
+		ComBase = gCom1Base;
+	else
+		ComBase = gCom2Base;
 
-static void vx800_writesioword(uint16_t reg, uint16_t val)
-{
-	outw(val, reg);
-}
 
-/* regs we use: 85, and the southbridge devfn is defined by the
-   mainboard
- */
+	//noharddrive
+	//set embeded com1 IO base = 0x3E8
+	//D17F0RB4
+	//ByteVal = 0xFD;
+	if(USE_COM1==1){
+		ByteVal = (u8)((gCom1Base >> 3) |0x80);
+		pci_write_config8(PCI_DEV(0, 17, 0), 0xB4, ByteVal);
+		ByteVal = pci_read_config8(PCI_DEV(0, 17, 0), 0xb2);
+		ByteVal = (ByteVal&0xf0)|0x04;
+		pci_write_config8(PCI_DEV(0, 17, 0), 0xB2, ByteVal);
+	}
+	//set embeded com2 IO base = 0x2E8
+	//D17F0RB5
+	//ByteVal = 0xDD;
+	if(USE_COM2==1){
+		ByteVal = (u8)((gCom2Base >> 3) |0x80);
+		pci_write_config8(PCI_DEV(0, 17, 0), 0xB5, ByteVal);
+		ByteVal = pci_read_config8(PCI_DEV(0, 17, 0), 0xb2);
+		ByteVal = (ByteVal&0x0f)|0x30;
+		pci_write_config8(PCI_DEV(0, 17, 0), 0xB2, ByteVal);
+	}
 
-static void enable_vx800_serial(void)
-{
-	outb(6, 0x80);
-	outb(0x03, 0x22);
 
-	//pci_write_config8(PCI_DEV(0,17,0),0xb4,0x7e);
-	//pci_write_config8(PCI_DEV(0,17,0),0xb0,0x10);
+	//disable interrupt
+	inb(ComBase + 3);
+	outb(ByteVal & 0x7F,ComBase + 3);
+	outb( 0x00,ComBase + 1);
 
-	// turn on pnp
-	vx800_writepnpaddr(0x87);
-	vx800_writepnpaddr(0x87);
-	// now go ahead and set up com1. 
-	// set address
-	vx800_writepnpaddr(0x7);
-	vx800_writepnpdata(0x2);
-	// enable serial out
-	vx800_writepnpaddr(0x30);
-	vx800_writepnpdata(0x1);
-	// serial port 1 base address (FEh)
-	vx800_writepnpaddr(0x60);
-	vx800_writepnpdata(0xfe);
-	// serial port 1 IRQ (04h)
-	vx800_writepnpaddr(0x70);
-	vx800_writepnpdata(0x4);
-	// serial port 1 control
-	vx800_writepnpaddr(0xf0);
-	vx800_writepnpdata(0x2);
-	// turn of pnp
-	vx800_writepnpaddr(0xaa);
+	//set baudrate
+	ByteVal = inb(ComBase + 3);
+	outb( ByteVal | 0x80,ComBase + 3);
+	outb(0x01,ComBase);
+	outb(0x00,ComBase + 1 );
 
-	// set up reg to set baud rate.
-	vx800_writesiobyte(0x3fb, 0x80);
-	// Set 115 kb
-	vx800_writesioword(0x3f8, 1);
-	// Set 9.6 kb
-	//      WRITESIOWORD(0x3f8, 12)
-	// now set no parity, one stop, 8 bits
-	vx800_writesiobyte(0x3fb, 3);
-	// now turn on RTS, DRT
-	vx800_writesiobyte(0x3fc, 3);
-	// Enable interrupts
-	vx800_writesiobyte(0x3f9, 0xf);
-	// should be done. Dump a char for fun.
-	vx800_writesiobyte(0x3f8, 48);
-	outb(7, 0x80);
+	//set  frame  fromat
+	ByteVal = inb(ComBase + 3);
+	outb( ByteVal & 0x3F,ComBase + 3);
+	outb(0x03,ComBase + 3 );
+	outb(0x00,ComBase + 2);
+	outb(0x00,ComBase + 4);
+
+	/*send a 'A' to test the function of COM*/
+	//outb(0x41,ComBase); 
 }
+
+static void enable_vx800_serial(void) 
+{
+	EmbedComInit();
+
+	/*enable COM at 2E8-2EF(COM4) and 3E8-3EF(COM3),external COM port (if it is ON your MB)*/
+	pci_write_config8(PCI_DEV(0, 17, 0), 0x6e, 0xdf);
+}
\ No newline at end of file
Index: src/northbridge/via/vx800/vx800_nb_pmu.c
===================================================================
--- src/northbridge/via/vx800/vx800_nb_pmu.c	(Revision 0)
+++ src/northbridge/via/vx800/vx800_nb_pmu.c	(Revision 0)
@@ -0,0 +1,61 @@
+/*
+ * This file is part of the coreboot project.
+ *
+ * Copyright (C) 2009 One Laptop per Child, Association, Inc.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; version 2 of the License.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
+ */
+
+#include <device/device.h>
+#include <device/pci.h>
+#include <device/pci_ops.h>
+#include <device/pci_ids.h>
+#include <console/console.h>
+#include "chip.h"
+#include <arch/io.h>
+#include "vx800.h"
+#include "vx800_pci_io_modify_ops.h"
+void nb_pmu_init(device_t dev)
+{		
+	pci_modify_config8(dev, 0x84, 0x00, 0xDB);
+	pci_modify_config8(dev, 0x85, 0x00, 0x05);
+	pci_modify_config8(dev, 0x89, 0x00, 0xF8);
+	pci_modify_config8(dev, 0x8B, 0x00, 0xBF);
+	pci_modify_config8(dev, 0x8D, 0x00, 0xFC);
+	pci_modify_config8(dev, 0x8E, 0x00, 0x19);
+	pci_modify_config8(dev, 0x8F, 0x03, 0x00);
+	pci_modify_config8(dev, 0x90, 0x00, 0xFF);
+	pci_modify_config8(dev, 0x91, 0x00, 0xFF);
+	pci_modify_config8(dev, 0x92, 0x00, 0xCC);
+	pci_modify_config8(dev, 0xA0, 0x00, 0x80);
+	pci_modify_config8(dev, 0xA1, 0x00, 0xE0);
+	pci_modify_config8(dev, 0xA2, 0x00, 0xD6);
+	pci_modify_config8(dev, 0xA3, 0x00, 0x80);
+	pci_modify_config8(dev, 0xA8, 0x00, 0x20);
+}
+
+static struct device_operations nb_pmu_ops = {
+	.read_resources	  = pci_dev_read_resources,
+	.set_resources	  = pci_dev_set_resources,
+	.enable_resources = pci_dev_enable_resources,
+	.init		  = nb_pmu_init,
+	.enable		  = 0,
+	.ops_pci	  = 0,
+};
+
+static struct pci_driver via_nb_pmu_driver __pci_driver = {
+	.ops    = &nb_pmu_ops,
+	.vendor = PCI_VENDOR_ID_VIA,
+	.device = PCI_DEVICE_ID_VIA_VX800_NB_PMU,
+};
Index: src/northbridge/via/vx800/final_setting.c
===================================================================
--- src/northbridge/via/vx800/final_setting.c	(Revision 4427)
+++ src/northbridge/via/vx800/final_setting.c	(Arbeitskopie)
@@ -81,7 +81,6 @@
 	{0x60, 0xff, 0xD0},
 	{0x66, 0xcf, 0x80},	// DRAMC queue > 2
 	{0x69, 0xff, 0x07},	// Enable multiple page
-	{0x95, 0x00, 0x0D},
 	{0x96, 0x0F, 0xA0},
 	{0xFB, 0x00, 0x3E},
 	{0xFD, 0x00, 0xA9},
@@ -112,12 +111,26 @@
 	//enable dram By-Rank self refresh
 	Data = pci_read_config8(MEMCTRL, 0x96);
 	Data &= 0xF0;
-	for (i = 0x01; i < 0x10; i = i << 1) {
+	for (i = 0x01; i < (1<<MAX_RANKS); i = i << 1) {
 		if ((DramAttr->RankPresentMap & i) != 0x00)
 			Data |= i;
 	}
 	pci_write_config8(MEMCTRL, 0x96, Data);
 
+	u8 shift = 1;
+	Data=0;
+	for (i = 0; i < MAX_RANKS; i++){
+	       if ((DramAttr->RankPresentMap & shift) != 0){
+			Data|=1<<(i*2);
+        	}
+	       shift <<= 1;
+	}
+	pci_write_config8(MEMCTRL, 0x95,Data);
+
+	Data=pci_read_config8(MEMCTRL, 0xde);
+	Data |= 0x04;
+	pci_write_config8(MEMCTRL, 0xde,Data);
+
 	for (i = 0; i < PM_table_item; i++) {
 		Data = pci_read_config8(PCI_DEV(0, 0, 4), PM_table[i][0]);
 		Data = (u8) ((Data & PM_table[i][1]) | PM_table[i][2]);
Index: src/northbridge/via/vx800/vx800_early_smbus.c
===================================================================
--- src/northbridge/via/vx800/vx800_early_smbus.c	(Revision 4427)
+++ src/northbridge/via/vx800/vx800_early_smbus.c	(Arbeitskopie)
@@ -203,7 +203,7 @@
 
 	dev =
 	    pci_locate_device(PCI_ID
-			      (PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX855_LPC),
+			      (PCI_VENDOR_ID_VIA, PCI_DEVICE_ID_VIA_VX800_LPC),
 			      0);
 
 	if (dev == PCI_DEV_INVALID) {
